// Ein Demoprogramm fr die Vorlesung Generative Computergrafik 
// J.L., 14. Oktober 2000 
 
import java.awt.*; 
import java.awt.event.*; 
import java.awt.geom.*; 
import javax.swing.*; 
import javax.swing.event.*; 
 
public class java2DExperimente { 
    public static void main( String[] args ) { 
        new java2DExperimente(); 
    } 
 
    JFrame myFrame = new JFrame("java2DExperimente"); //das Fenster 
    Container myPane = myFrame.getContentPane(); //sein Inhalt 
    JSlider mySlider = new JSlider(JSlider.VERTICAL, 0, 255, 128); //ein Schieberegler 
    DoodlePanel myDoodlePanel = new DoodlePanel(); //eine Zeichenflche 
    JPanel myOptions = new JPanel(); //hier kommen die Wahlknpfe drauf 
    ButtonGroup myButtonGroup = new ButtonGroup(); //lst die Wahlknpfe gegenseitig aus 
     
    java2DExperimente() { 
        //Die folgendem Zeilen teilen dem Fenster myFrame mit, dass es Ereignisse 
        //an ein im Fluge konstruiertes WindowAdapter-Objekt melden soll. 
        //Im WindowAdapter-Objekt wird ebenfalls im Fluge die Methode 
        //windowClosing(...) berschrieben. Dadurch passiert Folgendes: 
        //Klickt der Benutzer auf das Schliefeld (X) des Fensters, ruft Swing 
        //die neue Methode windowClosing(...) auf. Diese wiederum beendet 
        //das Programm mittels System.exit(0). 
        myFrame.addWindowListener ( new WindowAdapter() { 
            public void windowClosing(WindowEvent e) { 
                System.exit(0); 
            } 
        } ); 
         
        JRadioButton radioButton; 
         
        //Das Folgende wird allen Knpfen zugewiesen, damit etwas passiert, 
        //wenn man einen Knopf drckt. 
        ActionListener myButtonListener = new ActionListener() { 
            public void actionPerformed(ActionEvent e) { 
                //Andere Option wurde gewhlt. 
                myDoodlePanel.option = myButtonGroup.getSelection().getActionCommand(); 
                //entsprechende Variable ndern 
                myDoodlePanel.repaint(); 
                //Nachricht an Swing: Grafik muss neu gezeichnet werden. 
                //(Swing ruft dann alsbald die Methode paint aller Elemente auf.) 
            } 
        }; 
        
        radioButton = new JRadioButton("Fllung/Strichstrke");
        //neuen Knopf mit Titel "Fllung/..." erzeugen
        myButtonGroup.add(radioButton); 
        //zu logischer Gruppe hinzufgen (gegenseitiges Auslsen)
        myOptions.add(radioButton);
        //zu grafischer Gruppe hinzufgen
        radioButton.setActionCommand("Fllung");
        //Dies ist die Kennung, mit der wir den Knopf als "Ereignis" herausfischen.
        radioButton.setSelected(true);
        //Dieser Knopf soll zu Beginn gedrckt sein.
        radioButton.addActionListener(myButtonListener);
        //ndert sich etwas an diesem Knopf, soll myButtonListener.actionPerformed
        //aufgerufen werden.
        
        radioButton = new JRadioButton("Transformation/Compositing");
        //siehe oben
        myButtonGroup.add(radioButton); 
        myOptions.add(radioButton);
        radioButton.setActionCommand("Transformation"); 
        radioButton.addActionListener(myButtonListener); 
        
        radioButton = new JRadioButton("Verlauf/Clipping");
        //siehe oben
        myButtonGroup.add(radioButton); 
        myOptions.add(radioButton);
        radioButton.setActionCommand("Verlauf"); 
        radioButton.addActionListener(myButtonListener); 
         
        myDoodlePanel.option = myButtonGroup.getSelection().getActionCommand(); 
        //Anfangsstellung der Wahlknpfe in entsprechende Variable bertragen 
         
        myFrame.setSize(800, 400); 
        //Anfangsgre des Fensters 
        myFrame.setLocation(50, 50); 
        //Anfangsposition des Fensters (fast in der oberen linken Ecke) 
         
        myPane.setLayout(new GridBagLayout()); 
        //Objekt, das die Anordnung der Elemente auf den Bildschirm steuert 
        GridBagConstraints myConstraints = new GridBagConstraints(); 
        //Objekt, in dem man die gewnschte Anordnung der Elemente ablegt. 
        //Wird hier zweimal mit jeweils verschiedenen Wnschen benutzt. 
         
        myConstraints.fill = GridBagConstraints.BOTH; 
        //Zeichenflche soll sich im Fenster ausdehnen 
        myConstraints.weightx = 1.0; 
        myConstraints.weighty = 1.0; 
        //Verhltnis, in dem sich die Zeichenflche zu anderen Elementen ausdehnt 
        myConstraints.gridx = 0; 
        myConstraints.gridy = 0; 
        //Zeichenflche sitzt links in der Zeile null. 
        myPane.add(myDoodlePanel, myConstraints); 
         
        myConstraints.weightx = 0.0; 
        myConstraints.weighty = 0.0; 
        //Panel mit Wahlknpfen nur so breit, wie es sein muss 
        myConstraints.gridx = 0; 
        myConstraints.gridy = 1; 
        myConstraints.gridwidth = 2; 
        //Wahlknpfe sitzen links in der Zeile eins und gehen ber beide Spalten.         
        myPane.add(myOptions, myConstraints); 
         
        mySlider.setMajorTickSpacing(64); 
        //vier lange Teilstriche am Schieberegler (256/4 = 64) 
        //Ganz oben beim Wert 256 se der fnfte lange Strich, 
        //aber der Schieberegler geht nur bis 255 statt bis 256. 
        mySlider.setMinorTickSpacing(32); 
        //auf jeweils halber Distanz einen kurzen Teilstrich 
        mySlider.setPaintTicks(true); 
        myConstraints.weightx = 0.0; 
        myConstraints.weighty = 0.0; 
        //Schieberegler nur so breit, wie er sein muss 
        myConstraints.gridx = 1; 
        myConstraints.gridy = 0; 
        myConstraints.gridwidth = 1; //zurckstellen, weil oben verstellt 
        //Schieberegler sitzt rechts in der Zeile null. 
        myPane.add(mySlider, myConstraints);       
         
        myDoodlePanel.sliderValue = mySlider.getValue(); 
        //Anfangsposition des Reglers in entsprechende Variable bertragen 
         
        //Die folgendem Zeilen teilen dem Regler mySlider mit, dass er Ereignisse 
        //an ein im Fluge konstruiertes ChangeListener-Objekt melden soll. 
        //Wird der Regler verstellt, ruft Swing die berschriebene Methode 
        //stateChanged(...) auf. 
        mySlider.addChangeListener(new ChangeListener() { 
            public void stateChanged(ChangeEvent e) { 
                //Der Schieberegler wurde verstellt. 
                myDoodlePanel.sliderValue = mySlider.getValue(); 
                //entsprechende Variable ndern 
                myDoodlePanel.repaint(); 
                //Nachricht an Swing: Grafik muss neu gezeichnet werden. 
                //(Swing ruft dann alsbald die Methode paint aller Elemente auf.) 
            } 
        } ); 
         
        myFrame.setVisible(true); 
        //Fenster anzeigen 
    } 
} 
 
class DoodlePanel extends JPanel { 
 
    int sliderValue; 
    //Hier wird der aktuelle Stand des Schiebereglers abgelegt. 
    String option; 
    //Hier wird das ActionCommand des aktuell gewhlten Wahlknopfs abgelegt. 
     
    public void paint(Graphics g) { 
        //Swing ruft diese Methode auf, um dem Objekt Bescheid zu sagen: 
        //Bitte Flche neu zeichnen, z.B. weil die Fenstergre verndert wurde 
        //oder weil ein anderes, darber liegendes Fenster verschoben wurde 
        //oder weil das Programm es mittels repaint() selbst angefordert hat. 
         
        super.paint(g); 
        //Bildflche leeren etc.; das bernimmt die gleichnamige Methode der Mutterklasse (super) 
        Graphics2D g2 = (Graphics2D) g; 
        //Wir wollen Java2D verwenden und brauchen dazu einen Graphics2D-Grafikkontext,
        //nicht die alte Art von Java-Grafikkontext. 
 
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        //Kantenglttung (Antialising) anschalten
        
        if (option.equals("Fllung")) //Wahlknopf "Fllung" ist gedrckt
        {
            g2.setStroke(new BasicStroke(1+sliderValue/32));
            //Strichstrke hngt von Schieberegler ab.
            
            g2.setPaint(Color.white); //vordefinierte Farbe
            g2.fillOval(20, 30, 200, 300); //Ellipsenflche ausmalen
            g2.setPaint(Color.red); //vordefinierte Farbe
            g2.drawOval(20, 30, 200, 300); //Randkurve der Ellipse zeichnen
            //Erst fill, dann draw, sonst wird der innere Rand des Umrisses bermalt!
            
            Shape myCurve = new Ellipse2D.Double(50, 50, 400, 200);
            //Eine Ellipse erzeugen und als Vektorgrafikobjekt zwischenspeichern.
            g2.setPaint(new Color(sliderValue, 128, sliderValue/2));
            //Farbe auf reglergesteuerten Phantasiewert stellen.
            g2.fill(myCurve);
            //Flche der zwischengespeicherten Ellipse ausmalen
            g2.setPaint(Color.black); //vordefinierte Farbe
            g2.draw(myCurve); //Randkurve der zwischengespeicherten Ellipse zeichnen
            
        }  else if (option.equals("Transformation")) //Wahlknopf "Transformation" ist gedrckt
        {
            Shape myCurve = new Ellipse2D.Double(200, 50, 400, 200);
            //Eine Ellipse erzeugen und als Vektorgrafikobjekt zwischenspeichern.
            
            for(int i=0; i<5; i++) //Ellipse gleich fnfmal ausgeben.
            {
                g2.setPaint(new Color(30*i, 128, 255-40*i));
                //in jedem Durchlauf der Schleife eine andere Farbe
                g2.rotate(Math.PI/40*i);
                //Alle kommenden Zeichenbefehle werden gedreht ausgefhrt,
                //z.B. bei rotate(Math.PI/2) um 90 im Uhrzeigersinn gedreht. 
                g2.translate(sliderValue*i/5.0, -sliderValue*i/5.0);
                //Alle kommenden Zeichenbefehle werden verschoben ausgefhrt,
                //bei translate(x,y) um x nach rechts und y nach unten.
                g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, (float) ((5-i)/5.0)));
                //Alles Kommende um den angegebenen Alphawert 0...1 halbtransparent zeichnen;
                //hngt hier vom Schleifenindex ab.
                g2.fill(myCurve);
                //Flche der zwischengespeicherten Ellipse ausmalen.
            }
            
        } else if (option.equals("Verlauf")) //Wahlknopf "Verlauf" ist gedrckt
        {
            for( int x=100; x<700; x+=50)
            {
                for( int y=50; y<350; y+=30)
                {
                    g2.drawString("ABC", x, y);
                    //Zeichen "ABC" an Stelle x, y zeichnen
                }
            }
            
            g2.setClip(new Ellipse2D.Double(150+1.5*sliderValue, 20, 200, 250));
            //Zeichnung ab hier auf Ellipse beschrnken (Clipping Path).
            //Die wird per Schieberegler bewegt.
            
            g2.setPaint(new GradientPaint(0, 10, Color.red, 500, 400, Color.blue));
            //Fllung mit Farbverlauf: Am Punkt (0,10) liegt Rot, bei (500,400) Blau. 
            g2.fillOval(200, 50, 400, 200);
            //Ellipsenflche ausmalen.
        }
    }
}